<?php
if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/../../../');
require_once(DOKU_INC.'inc/init.php');
require_once(DOKU_INC.'inc/common.php');
require_once(DOKU_INC.'inc/pageutils.php');
require_once(DOKU_INC.'inc/auth.php');

function _nstree($path='', $nsparent=''){
    require_once(DOKU_INC.'inc/search.php');
    global $conf;

    if ($path=='') $path = $conf['datadir'];
    if (!is_dir($path)) $path  = str_replace(':','/',$path);

    $nshide = array('playground');
    $data = array();
    search($data, $path, 'search_index', array('ns' => ''));
    $html = '';
    if (count($data) > 0){
        foreach($data as $nspage) {
            if ($nspage['type']=='d') {
                if(in_array($nspage['id'], $nshide)) continue;
                $linkid = substr($nsparent.':'.$nspage['id'], 1);
                $html .= '<li ><a href="#" id="'. $linkid.'">'.$nspage['id'].'</a>';
                $html .=_nstree($path.'/'.$nspage['id'], $nsparent.':'.$nspage['id']);
                $html .'</li>';
            }
        }
    }
    if (trim($html) != '') $html = '<ul>'.trim($html).'</ul>';
    return $html;
}

function _optionsNS($data) {
    global $ID;
    $ns=explode(':',$ID);
    array_pop($ns);
    $ns=implode(':',$ns);
    $r=_getnslist("");
    $ret = '';
    foreach ($r as $k => $v) {
        if ($data != ''){
            if (strpos(":".$v,":".$data.":")===false) continue;
        }
        $vv=explode(':',$v);
        $vv=str_repeat('&nbsp;&nbsp;',substr_count($v, ':')).$vv[count($vv)-1];
        $ret.='<option '.(($ns==$v)?'selected="selected"':'').' value="'.$v.'">'.$vv.'</option>';
    }
    $ret.='</optgroup>';
    return $ret;
}

function _getnslist($tns='') {
    require_once(DOKU_INC.'inc/search.php');
    global $conf;

    $ns_hide = array('playground');
    if ($tns=='') $tns = $conf['datadir'];
    if (!is_dir($tns)) $tns  = str_replace(':','/',$tns);
    $data = array();
    search($data,$tns,'search_index',array('ns' => ''));
    $result = array();
    foreach($data as $k => $v) {
        if ($v['type']=='d') {
            if(in_array($v['id'], $ns_hide)) continue;
            array_push($result,$v['id']);
            $r=_getnslist($tns.'/'.$v['id']);
            foreach ($r as $vv) {
                    array_push($result,$v['id'].':'.$vv);
            }
        }
    }
    return $result;
}

function _getNS($rootDir,$namedir){
    $dirContent = scandir($rootDir);
    $result = '';
    foreach($dirContent as $key => $content) {
        if ($content=='.' || $content == '..' || $content == 'wiki' || $content == 'playground' || $content == '.svn') continue;
        $path = $rootDir.'/'.$content;
        if(is_dir($path) && is_readable($path)) {
            if($namedir !='') $parentdir = $namedir.':'.$content;
            else $parentdir = $content;
            $result .= '<option>'.$parentdir.'</option>';
            $result .= _getNS($path, $parentdir);
        }
    }
    return $result;
}

?>
