<?php
/**
 * htmlexport - Render model1
 *
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Eduard Diaz, Scopia visual interface systems SL <edudiaz@scopia.es>
 */
// must be run within Dokuwiki
if(!defined('DOKU_INC')) die();

// we inherit from the base renderer
//require_once DOKU_INC.'inc/parser/renderer.php';
require_once DOKU_INC.'inc/parser/xhtml.php';

/**
 * The Renderer
 */
class renderer_plugin_htmlexport_model4 extends Doku_Renderer_xhtml {
    var $version = '2011-11-12';

    var $info = array(
        'cache' => false, // may the rendered result cached?
        'toc'   => false, // render the TOC?
    );

    /**
     * return some info
     */
    function getInfo(){
        return array(
            'author' => 'Eduard Diaz',
            'email'  => 'edudiaz@scopia.es',
            'date'   => $this->version,
            'name'   => 'htmlexport model4 (Render plugin)',
            'desc'   => 'htmlexport plugin for a custom template',
            'url'    => 'http://www.scopia.es'
        );
    }

    /**
     * the format we produce
     */
    //function getFormat(){ return 'xhtml'; }
    function canRender($format) { return ($format=='xhtml'); }

    function reset() {
       $this->doc = '';
       $this->footnotes = array();
       $this->lastsec = 0;
       $this->store = '';
       $this->_counter = array();
    }
    function cdata($text) {
        $this->doc .= $this->_xmlEntities($text);
    }

    /*
     * Initialize the rendering
     */
    function document_start() {
        global $conf;
        global $lang;
        global $INFO;
        global $ID;
        global $PARENTNS;
        // call the parent
        parent::document_start();

        if ($PARENTNS !=''){
            $dir = $PARENTNS;
            $dir = str_replace(':','/',$dir);
            $dir = $conf['datadir'].'/'.$dir;
        }
        else if (isset($_REQUEST['parent'])){
            $dir = $_REQUEST['parent'];
            $dir = str_replace(':','/',$dir);
            $dir = $conf['datadir'].'/'.$dir;
        }else{
            $dir = getNS($ID);
            $dir = str_replace(':','/',$dir);
            $dir = $conf['datadir'].'/'.$dir;
        }

        $relurl = $this->getRelUrl();

        $meta = p_get_metadata($id);

        //$title = p_get_first_heading($conf['start']);
        $title = p_get_metadata($ID,'title',true);

        if(!$title) $title = $conf['start'];

        $tblguia = $this->get_scopia_metaFN_type();
        if(in_array($tblguia, array("table", "tree"))){
            //$tblguiascript = '<script src="'.$relurl.'js/jquery.tblguia.js" type="text/javascript"></script>'."\n";
            //$tblguiascript .= '<script type="text/javascript">$(document).ready(function(){ $("#continguts").tblguia_'.$tblguia.'();});</script>';
            //$tblguiascript .= '<link href="'.$relurl.'css/taula_guia.css" media="all" rel="stylesheet" type="text/css"/>';
            $tblguiascript = '
<link href="'.$relurl.'css/taula_guia.css" media="all" rel="stylesheet" type="text/css"/>
<script src="'.$relurl.'js/jquery.tblguia.js" type="text/javascript"></script>
<script type="text/javascript">
$(document).ready(function(){
    $("#navegacio").hide();
    $("#dokucontinguts").css("width","auto");
    $("#continguts").tblguia_'.$tblguia.'();
});
</script>';
        }else{
            $tblguiascript = '';
        }

        // send the content type header
        header('Content-Type: text/html; charset=utf-8');
        $this->doc = '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="'.$conf['lang'].'" lang="'.$conf['lang'].'" dir="'.$lang['direction'].'">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>'.hsc($conf['title']).' - '.$title.'</title>
<link href="'.$relurl.'css/layout_EAPC.css" media="all" rel="stylesheet" type="text/css"/>
<link href="'.$relurl.'css/print_EAPC.css" media="print" rel="stylesheet" type="text/css"/>
<script src="'.$relurl.'js/jquery-1.4.2.min.js" type="text/javascript"></script>
<script src="'.$relurl.'js/base.js" type="text/javascript"></script>
<script src="'.$relurl.'js/swfobject.js" type="text/javascript"></script>
'.$tblguiascript.'
</head>
<body>
<div id="pagina">
<div id="capssalera"></div>
<div class="filariadna"><p>'.$this->youarehere($relurl, $dir).'</p></div>
<div id="navegacio">'.$this->menuWidget($dir).'</div>
<div id="dokucontinguts">
<div id="continguts">';
    }

    /**
     * Closes the document
     */
    function document_end(){
        $this->addfootnotes();
$this->doc .= '
</div>
</div>
<br class="fix"/>
<div id="peu"></div>
</div>
</body>
</html>';
        // make sure there are no empty paragraphs
        $this->doc = preg_replace('#<p>\s*</p>#','',$this->doc);
    }
    /**
     * output namespaces widget menu
     */
    function menuWidget($dir){
        global $conf;
        $strWidget  = '<h2>Menú</h2>';
        $strWidget .= '<ul>';
        $strWidget .= '<li><a href="'.$this->getRelUrl().''.$conf['start'].'.html">'.hsc($conf['start']).'</a></li>';
        $strWidget .= $this->getMenu($dir, '');
        $strWidget .= '</ul>';
        return $strWidget;
    }
    /**
     * get namespaces list
     */
    function getMenu($rootDir,$namedir){
        global $conf;
        global $ID;
        if (!is_dir($rootDir))return;
        $tmpmnu = '';
        $relurl = $this->getRelUrl();
        $dirContent = scandir($rootDir);
        foreach($dirContent as $key => $content) {
            if ($content=='.' || $content == '..' || $content == 'wiki' || $content == 'playground' || $content == '.svn') continue;
            $path = $rootDir.'/'.$content;
            if(is_dir($path) && is_readable($path)) {
                if($namedir !='') $parentdir = $namedir.'/'.$content;
                else $parentdir = $content;
                $tmpmnu = $this->getMenu($path, $parentdir);
                if ($tmpmnu){
                    $result .= '<li><a href="#" class="submnu">'.$content.'</a>';
                    if($this->ulSelected($path)){
                        $result .= '<ul class="visible">';
                    }else{
                        $result .= '<ul>';
                    }
                    $result .= '<li><a href="'.$relurl.''.$parentdir.'/'.$conf['start'].'.html">'.hsc($conf['start']).'</a></li>';
                    $result .= $tmpmnu;
                    $result .= '</ul>';
                    $result .= '</li>';
                }else{
                    $pagename = str_replace($conf['datadir'], '', $path);
                    $pagename = str_replace('/',':', $pagename);
                    $pagename = $pagename .':'.$conf['start'];
                    $title = $this->get_pagetitle($pagename);
                    $result .= '<li><a href="'.$relurl.''.$parentdir.'/'.$conf['start'].'.html">'.hsc($title).'</a></li>';
                    //$result .= '<li><a href="'.$relurl.''.$parentdir.'/'.$conf['start'].'.html">'.$content.'</a></li>';
                }
            }
        }
        return $result;
    }

    function getRelUrl(){
        global $ID;
        global $PARENTNS;
        if ($PARENTNS !=''){
           $parent =  $PARENTNS;
        }else if(isset($_REQUEST['parent'])){
            $parent = $_REQUEST['parent'];
        }else{
            return '';
        }
        $docns = getNS($ID);
        $docns = str_replace($parent,'',$docns);
        // page names noNS($ID);
        $docns = str_replace(noNS($ID),'',$docns);
        $lsturl = split(':',$docns);
        $relurl = '';
        if (count($lsturl)>=1){
            for ($i=0; $i<count($lsturl);$i++) {
                if (trim($lsturl[$i])!='')
                    $relurl .= "../";
            }
        }
        return $relurl;
    }
    function ulSelected($path){
        global $ID;
        global $conf;
        $npath = str_replace($conf['datadir'].'/','',$path);
        $npath = str_replace('/',':',$npath);
        $ns = getNS($ID);
        //$ns = substr($ns, 0, strripos($ns, ':'));
        if (ereg($npath, $ns)){
            return true;
        }else{
            return false;
        }
    }
    function youarehere($relurl='', $from='', $sep=' &raquo; '){
        // contruye las migas de pan
        global $conf;
        global $ID;
        global $lang;

        //convertimos el $from en un namespace para restarlo del $ID
        $from = str_replace($conf['datadir'].'/','',$from);
        $from = str_replace('/',':',$from);
        $from_ns = $from;
        $from = str_replace($from.':','',$ID);
        $from_ns = str_replace($from,'',$from_ns);
        $parts = explode(':', $from);
        $pagename = noNS($ID);

        //preparamos la salida
        $result = '';
        $result .= '<span class="filariadna_label">'.$lang['youarehere'].': </span><a href="'.$relurl.''.$conf['start'].'.html">'.hsc($conf['start']).'</a>';

        //chequeamos si hay mas de un nivel
        if (count($parts)==1){ //1 nivel, sin subnamespaces, paginas hermanas
            if ($parts[0]!=$conf['start']){
                #$title = $parts[0];
                $title = p_get_metadata($ID,'title',true);
                $result .= $sep; //separador de enlaces
                $result .= '<span class="filariadna_pg">'.hsc($title).'</span>';
            }
        }else{ //Subniveles, con subnamespaces
            $preNS = $relurl;
            $count = 0;
            foreach($parts as $part){

                //chequeamos si es una pagina o un namespace
                if($part == $conf['start'] || $part == $pagename){ // es una pagina

                    //titulo
                    if ($pagename != $conf['start']){
                        $result .= $sep; //separador de enlaces
                        $title = $this->get_pagetitle($ID);
                        if(!$title) $title = $pagename;
                        //output
                        //$result .= '<span class="filariadna_pg">'.hsc($title).'</span>';
                        $result .= ' <a href="#">'.hsc($title).'</a>';
                    }

                }else{// es un namespace
                    //returns a full page id
                    $result .= $sep; //separador de enlaces

                    //titulo
                    if ($preNS ==''){
                        $startpagename = $from_ns.$part.':'.$conf['start'];

                    }else{
                        $startpagename = $from_ns .':'. implode(':',array_slice($parts, 0, $count)).':'.$part.':'.$conf['start'];
                    }
                    $title = $this->get_pagetitle($startpagename);
                    if(!$title) $title = $part;

                    //construccion del enlace
                    if ($preNS =='') $link = $part.'/'.$conf['start'].'.html';
                    elseif($preNS == $relurl) $link = $preNS.$part.'/'.$conf['start'].'.html';
                    else $link = $preNS.'/'.$part.'/'.$conf['start'].'.html';

                    //output
                    $result .= ' <a href="'.$link.'">'.hsc($title).'</a>';

                    //guardamos la ruta para el siguiente
                    if ($preNS == $relurl)$preNS .=$part;
                    else $preNS .='/'.$part;
                }
                $count ++;
            }
        }
        return $result;
    }

    function get_pagetitle($pagename){
        /*
          Devuelve el titulo de una pagina dokuwiki
        */
        $output = p_get_metadata(cleanID($pagename),'title', false);
        if (!$output) {
            $output = tpl_pagetitle($pagename, true);
        }
        return $output;
    }

    function addfootnotes(){
        if ( count ($this->footnotes) > 0 ) {
            $this->doc .= '<div class="footnotes">'.DOKU_LF;

            $id = 0;
            foreach ( $this->footnotes as $footnote ) {
                $id++;   // the number of the current footnote

                // check its not a placeholder that indicates actual footnote text is elsewhere
                if (substr($footnote, 0, 5) != "@@FNT") {

                    // open the footnote and set the anchor and backlink
                    $this->doc .= '<div class="fn">';
                    $this->doc .= '<sup><a href="#fnt__'.$id.'" id="fn__'.$id.'" name="fn__'.$id.'" class="fn_bot">';
                    $this->doc .= $id.')</a></sup> '.DOKU_LF;

                    // get any other footnotes that use the same markup
                    $alt = array_keys($this->footnotes, "@@FNT$id");

                    if (count($alt)) {
                      foreach ($alt as $ref) {
                        // set anchor and backlink for the other footnotes
                        $this->doc .= ', <sup><a href="#fnt__'.($ref+1).'" id="fn__'.($ref+1).'" name="fn__'.($ref+1).'" class="fn_bot">';
                        $this->doc .= ($ref+1).')</a></sup> '.DOKU_LF;
                      }
                    }

                    // add footnote markup and close this footnote
                    $this->doc .= $footnote;
                    $this->doc .= '</div>' . DOKU_LF;
                }
            }
            $this->doc .= '</div>'.DOKU_LF;
        }
    }
    /**
     * Function to save the data in a metafile with extension "*.scopia"
     * Save the tbltype variable
     *
     * @param $aStatus String The "Taula Guia" format ("tree" or "table") to generate.
     */
    function get_scopia_metaFN_type(){
        global $ID;

        // get scopia meta file name
        $file = metaFN($ID, '.scopia');
        $data = array();
        if (@file_exists($file)) {
            $data = unserialize(io_readFile($file, false));
            if (!empty($data['type'])) return $data['type'];
            else return false;
        }
        return false;
    }
}
?>
